﻿--[[

	Give Me Health: 
		copyright 2005 by Stephen Blaising
	Version: 1.10.00
	-----------------
	Version 1.12.2 to 2.4.1 by Mileg
        -----------------
        Version 3.1.0 to Current by merk66

]]

GMH_ADDONNAME = "Give Me Health";
GMH_MACRONAME = "GMHealth";
GMH_MANAMACRONAME = "GMMana";
GMH_BANDAGEMACRONAME = "GMBandage";
GMH_FOODMACRONAME = "GMFood";
GMH_WATERMACRONAME = "GMWater";
GMH_HEALTHSTONENAME = "GMHStone";
GMH_BUFFMACRONAME = "GMBuff";

local GMH_VERSION = "3.3.1";

local GiveMeHealth_Loaded = false;
local GiveMeHealth_Enabled = false;
local notInCombat = true;
local saveType;
GMH_Save = {};
local PRIMARYbuff;
local SECONDARYbuff;
local TERTIARYbuff;
local Realm;
local Player;

local GMH_HPotions = {};
local GMH_MPotions = {};
local GMH_Bandages = {};
local GMH_Water = {};
local GMH_Food = {};
local GMH_Buff = {};
local GMH_PotionCnt = {};
local TempArray = {};
local GMH_LastItem = {};
local GMH_LastBackup = {};

local GHM_ZoneName = "";
local GHM_ZoneType = "";

function GiveMeHealth_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
	SlashCmdList["GIMMEHEALTHCOMMAND"] = GiveMeHealth_SlashHandler;
     	SLASH_GIMMEHEALTHCOMMAND1 = "/givemehealth";
     	SLASH_GIMMEHEALTHCOMMAND1 = "/gmh";

	
end


function GiveMeHealth_OnEvent()
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		
		if ( GetMacroIndexByName(GMH_MACRONAME) == 0 ) then
			CreateMacro(GMH_MACRONAME,7,"/gmh update=health\n/cast [mod:ctrl] "..ALCH.." ",0);
		end
		
		if ( GetMacroIndexByName(GMH_MANAMACRONAME) == 0 ) then
			CreateMacro(GMH_MANAMACRONAME,331,"/gmh update=mana\n/cast [mod:ctrl] "..ALCH.." ",0);
		end
		
		if ( GetMacroIndexByName(GMH_BANDAGEMACRONAME) == 0 ) then
			CreateMacro(GMH_BANDAGEMACRONAME,734,"/gmh update=bandage\n/cast [mod:ctrl] "..FAID.." ",0);
		end
		
		if ( GetMacroIndexByName(GMH_FOODMACRONAME) == 0 ) then
			CreateMacro(GMH_FOODMACRONAME,775,"/gmh update=food\n/cast [mod:ctrl] "..COOK.."\n/cast [button:2] "..CONJF.." ",0);
		end
		
		if ( GetMacroIndexByName(GMH_WATERMACRONAME) == 0 ) then
			CreateMacro(GMH_WATERMACRONAME,770,"/gmh update=water\n/cast [button:2] "..CONJW.." ",0);
		end
		if ( GetMacroIndexByName(GMH_HEALTHSTONENAME) == 0 ) then
			CreateMacro(GMH_HEALTHSTONENAME,805,"/gmh update=stone\n/cast [button:2] "..CHS.." ",0);
		end

		if ( GetMacroIndexByName(GMH_BUFFMACRONAME) == 0 ) then
			CreateMacro(GMH_BUFFMACRONAME,766,"/gmh update=buff\n/cast [mod:ctrl] "..CAMPFIRE.." ",0);
		end

		--GiveMeHealth_GetZoneType()
		GMH_Go(GMH_MACRONAME);
		GMH_Go(GMH_MANAMACRONAME);
		GMR_Go(GMH_BANDAGEMACRONAME);
		GMR_Go(GMH_FOODMACRONAME);
		GMR_Go(GMH_WATERMACRONAME);
                GMB_Go(GMH_BUFFMACRONAME);
			
			
		return;

        elseif ( event == "VARIABLES_LOADED" ) then
        	GiveMeHealth_InitVars();
        	GiveMeHealth_Print(GMH_ADDONNAME.." v"..GMH_VERSION.." Loaded");
			GiveMeHealth_Print("Type /gmh help for instructions");
		return;
			
		elseif ( event == "PLAYER_REGEN_ENABLED" ) then
			notInCombat = true;
			GMH_Go(GMH_MACRONAME);
			GMH_Go(GMH_MANAMACRONAME);
			GMR_Go(GMH_BANDAGEMACRONAME);
			GMR_Go(GMH_FOODMACRONAME);
			GMR_Go(GMH_WATERMACRONAME);
			GMR_Go(GMH_HEALTHSTONENAME);
                        GMB_Go(GMH_BUFFMACRONAME);
			--GiveMeHealth_Print("Exiting Combat");
		return;
			
		elseif ( event == "PLAYER_REGEN_DISABLED" ) then
			notInCombat = false;
			--GiveMeHealth_Print("Entering Combat");
		return;
			
		elseif ((event == "UNIT_INVENTORY_CHANGED" or event == "BAG_UPDATE") and notInCombat ) then
			--GiveMeHealth_Print("|cff0000CCUpdating Macros");
			GMH_Go(GMH_MACRONAME);
			GMH_Go(GMH_MANAMACRONAME);
			GMR_Go(GMH_BANDAGEMACRONAME);
			GMR_Go(GMH_FOODMACRONAME);
			GMR_Go(GMH_WATERMACRONAME);
			GMR_Go(GMH_HEALTHSTONENAME);
                        GMB_Go(GMH_BUFFMACRONAME);
		elseif ( event == "ZONE_CHANGED_NEW_AREA" ) then
			--GiveMeHealth_GetZoneType()
			GMH_Go(GMH_MACRONAME);
			GMH_Go(GMH_MANAMACRONAME);
			GMR_Go(GMH_BANDAGEMACRONAME);
			GMR_Go(GMH_FOODMACRONAME);
			GMR_Go(GMH_WATERMACRONAME);
			GMR_Go(GMH_HEALTHSTONENAME);
                        GMB_Go(GMH_BUFFMACRONAME);
        end
end

function GiveMeHealth_GetZoneType()
	if ( GHM_ZoneName ~= GetRealZoneText() ) then
		GHM_ZoneName = GetRealZoneText();
                if ( GHM_ZoneName == WSG or GHM_ZoneName == AV or GHM_ZoneName == AB or GHM_ZoneName == EOTS or GHM_ZoneName == SOTA ) then
			GHM_ZoneType = "BG";
		elseif ( GHM_ZoneName == BOT or GHM_ZoneName == EYE or GHM_ZoneName == MECH or GHM_ZoneName == ARCA ) then
			GHM_ZoneType = "TK";
		elseif ( GHM_ZoneName == SSC or GHM_ZoneName == UB or GHM_ZoneName == SV or GHM_ZoneName == SP ) then
			GHM_ZoneType = "CFR";
		elseif ( GHM_ZoneName == BEP or GHM_ZoneName == GL ) then
                        GHM_ZoneType = "BE";                
                elseif ( GHM_ZoneName == ARENA_BE or GHM_ZoneName == ARENA_D or GHM_ZoneName == ARENA_N or GHM_ZoneName == ARENA_ROL or GHM_ZoneName == ARENA_ROV ) then
                        GHM_ZoneType = "ARENA"; 
                else
			GHM_ZoneType = "ALL";
		end 
	end
end

function GiveMeHealth_SlashHandler(msg)

     if (msg) then
	  msg = string.lower(msg);
	end
	if (msg == "help") then
		GiveMeHealth_Print(GMH_ADDONNAME.." |cff3399CCv"..GMH_VERSION.." ");
		GiveMeHealth_Print("Type /Macro to open macro list");
		GiveMeHealth_Print("Drag macros to your action bar.");
		GiveMeHealth_Print("Left-Click macros does the following.");
		GiveMeHealth_Print("   GMHealth - Use best health potion.");
		GiveMeHealth_Print("   GMMana - Use best mana potion.");
		GiveMeHealth_Print("   GMBandage - Use best bandage.");
		GiveMeHealth_Print("   GMFood - Eat best food.");
		GiveMeHealth_Print("   GMWater - Drink best drink.");
		GiveMeHealth_Print("   GMBuff - Eat best buff food.");
		GiveMeHealth_Print("   GMHstone - Use best healthstone.");
		GiveMeHealth_Print("SHIFT-Click on macros to use second best item.");
		GiveMeHealth_Print("ALT-Click on potion macros to use potion out of combat.");
		GiveMeHealth_Print("CTRL-Click on macros to open relative craft (if you have it):");
		GiveMeHealth_Print("   GMFood - Cooking");
		GiveMeHealth_Print("   GMBandage - First Aid");
		GiveMeHealth_Print("   GMHealth or GMMana - Alchemy");
                GiveMeHealth_Print("   GMBuff - Basic Campfire");
                GiveMeHealth_Print("Right-Click GMFood or GMWater to conjure either (if you are a mage.)");
                GiveMeHealth_Print("Right-Click GMHstone to create a healthstone (if you are a warlock.)");
		GiveMeHealth_Print("/gmh buff - Displays the currently used buff food.");
		GiveMeHealth_Print("/gmh b1=[BUFFTYPE] will update the first buff used in sorting the GMBuff macro.");
		GiveMeHealth_Print("/gmh b2=[BUFFTYPE] will update the second buff used in sorting the GMBuff macro.");
		GiveMeHealth_Print("/gmh b3=[BUFFTYPE] will update the third buff used in sorting the GMBuff macro.");
		GiveMeHealth_Print("   Replace [BUFFTYPE] with the following:");
		GiveMeHealth_Print("    agi for agility");
		GiveMeHealth_Print("    arm for armor penetration");
		GiveMeHealth_Print("    atk for attack power");
		GiveMeHealth_Print("    crt for critical strike rating");
		GiveMeHealth_Print("    exp for expertise");
		GiveMeHealth_Print("    has for haste");
		GiveMeHealth_Print("    hp5 for health per 5");
		GiveMeHealth_Print("    hit for hit rating");
		GiveMeHealth_Print("    int for intellect");
		GiveMeHealth_Print("    mp5 for mana per 5");
		GiveMeHealth_Print("    oth for other (miscellaneous)");
		GiveMeHealth_Print("    res for resistance");
		GiveMeHealth_Print("    spl for spell power");
		GiveMeHealth_Print("    spi for spirit");
		GiveMeHealth_Print("    sta for stamina");
		GiveMeHealth_Print("    str for strength");
		
	elseif (msg == "update") then
		notInCombat = true;
		GMH_Go(GMH_MACRONAME);
		GMH_Go(GMH_MANAMACRONAME);
		GMR_Go(GMH_BANDAGEMACRONAME);
		GMR_Go(GMH_FOODMACRONAME);
		GMR_Go(GMH_WATERMACRONAME);
		GMR_Go(GMH_HEALTHSTONENAME);
                GMB_Go(GMH_BUFFMACRONAME);
	elseif (msg == "update=health") then
		GMH_Go(GMH_MACRONAME);
	elseif (msg == "update=mana") then
		GMH_Go(GMH_MANAMACRONAME);
	elseif (msg == "update=bandage") then
		GMR_Go(GMH_BANDAGEMACRONAME);
	elseif (msg == "update=food") then
		GMR_Go(GMH_FOODMACRONAME);
	elseif (msg == "update=water") then
		GMR_Go(GMH_WATERMACRONAME);
	elseif (msg == "update=stone") then
		GMR_Go(GMH_HEALTHSTONENAME);
	elseif (msg == "update=buff") then
		GMB_Go(GMH_BUFFMACRONAME);
		
	elseif (msg == "save") then
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=meat") then
		saveType = "meat";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=fish") then
		saveType = "fish";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=cheese") then
		saveType = "cheese";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=bread") then
		saveType = "bread";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=fungus") then
		saveType = "fungus";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");
	elseif (msg == "save=fruit") then
		saveType = "fruit";
		GMH_Save[Realm][Player].saveType = saveType;
		GiveMeHealth_Print("Saving ".. saveType.. " to be eaten last");

        elseif (msg == "buff") then
                GiveMeHealth_Print("First Choice: "..PRIMARYbuff);
                GiveMeHealth_Print("Second Choice: "..SECONDARYbuff);
                GiveMeHealth_Print("Third Choice: "..TERTIARYbuff);
        elseif (msg == "b1=agi") then
                PRIMARYbuff = "agility";
                GiveMeHealth_Print("Primary Buff set to Agility");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=agi") then
                SECONDARYbuff = "agility";
                GiveMeHealth_Print("Secondary Buff set to Agility");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=agi") then
                TERTIARYbuff = "agility";
                GiveMeHealth_Print("Tertiary Buff set to Agility");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=arm") then
                PRIMARYbuff = "armorpenetration";
                GiveMeHealth_Print("Primary Buff set to Armor Penetration");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=arm") then
                SECONDARYbuff = "armorpenetration";
                GiveMeHealth_Print("Secondary Buff set to Armor Penetration");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=arm") then
                TERTIARYbuff = "armorpenetration";
                GiveMeHealth_Print("Tertiary Buff set to Armor Penetration");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=atk") then
                PRIMARYbuff = "attackpower";
                GiveMeHealth_Print("Primary Buff set to Attack Power");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=atk") then
                SECONDARYbuff = "attackpower";
                GiveMeHealth_Print("Secondary Buff set to Attack Power");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=atk") then
                TERTIARYbuff = "attackpower";
                GiveMeHealth_Print("Tertiary Buff set to Attack Power");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=crt") then
                PRIMARYbuff = "critical";
                GiveMeHealth_Print("Primary Buff set to Critical Strike");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=crt") then
                SECONDARYbuff = "critical";
                GiveMeHealth_Print("Secondary Buff set to Critical Strike");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=crt") then
                TERTIARYbuff = "critical";
                GiveMeHealth_Print("Tertiary Buff set to Critical Strike");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=exp") then
                PRIMARYbuff = "expertise";
                GiveMeHealth_Print("Primary Buff set to Expertise");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=exp") then
                SECONDARYbuff = "expertise";
                GiveMeHealth_Print("Secondary Buff set to Expertise");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=exp") then
                TERTIARYbuff = "expertise";
                GiveMeHealth_Print("Tertiary Buff set to Expertise");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=has") then
                PRIMARYbuff = "haste";
                GiveMeHealth_Print("Primary Buff set to Haste");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=has") then
                SECONDARYbuff = "haste";
                GiveMeHealth_Print("Secondary Buff set to Haste");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=has") then
                TERTIARYbuff = "haste";
                GiveMeHealth_Print("Tertiary Buff set to Haste");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=hp5") then
                PRIMARYbuff = "healthper5";
                GiveMeHealth_Print("Primary Buff set to Health per 5");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=hp5") then
                SECONDARYbuff = "healthper5";
                GiveMeHealth_Print("Secondary Buff set to Health per 5");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=hp5") then
                TERTIARYbuff = "healthper5";
                GiveMeHealth_Print("Tertiary Buff set to Health per 5");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=hit") then
                PRIMARYbuff = "hitrating";
                GiveMeHealth_Print("Primary Buff set to Hit Rating");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=hit") then
                SECONDARYbuff = "hitrating";
                GiveMeHealth_Print("Secondary Buff set to Hit Rating");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=hit") then
                TERTIARYbuff = "hitrating";
                GiveMeHealth_Print("Tertiary Buff set to Hit Rating");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=int") then
                PRIMARYbuff = "intellect";
                GiveMeHealth_Print("Primary Buff set to Intellect");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=int") then
                SECONDARYbuff = "intellect";
                GiveMeHealth_Print("Secondary Buff set to Intellect");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=int") then
                TERTIARYbuff = "intellect";
                GiveMeHealth_Print("Tertiary Buff set to Intellect");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=mp5") then
                PRIMARYbuff = "manaper5";
                GiveMeHealth_Print("Primary Buff set to Mana per 5");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=mp5") then
                SECONDARYbuff = "manaper5";
                GiveMeHealth_Print("Secondary Buff set to Mana per 5");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=mp5") then
                TERTIARYbuff = "manaper5";
                GiveMeHealth_Print("Tertiary Buff set to Mana per 5");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=oth") then
                PRIMARYbuff = "other";
                GiveMeHealth_Print("Primary Buff set to Other");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=oth") then
                SECONDARYbuff = "other";
                GiveMeHealth_Print("Secondary Buff set to Other");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=oth") then
                TERTIARYbuff = "other";
                GiveMeHealth_Print("Tertiary Buff set to Other");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=res") then
                PRIMARYbuff = "resistance";
                GiveMeHealth_Print("Primary Buff set to Resistance");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=res") then
                SECONDARYbuff = "resistance";
                GiveMeHealth_Print("Secondary Buff set to Resistance");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=res") then
                TERTIARYbuff = "resistance";
                GiveMeHealth_Print("Tertiary Buff set to Resistance");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=spl") then
                PRIMARYbuff = "spellpower";
                GiveMeHealth_Print("Primary Buff set to Spell Power");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=spl") then
                SECONDARYbuff = "spellpower";
                GiveMeHealth_Print("Secondary Buff set to Spell Power");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=spl") then
                TERTIARYbuff = "spellpower";
                GiveMeHealth_Print("Tertiary Buff set to Spell Power");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=spi") then
                PRIMARYbuff = "spirit";
                GiveMeHealth_Print("Primary Buff set to Spirit");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=spi") then
                SECONDARYbuff = "spirit";
                GiveMeHealth_Print("Secondary Buff set to Spirit");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=spi") then
                TERTIARYbuff = "spirit";
                GiveMeHealth_Print("Tertiary Buff set to Spirit");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=sta") then
                PRIMARYbuff = "stamina";
                GiveMeHealth_Print("Primary Buff set to Stamina");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=sta") then
                SECONDARYbuff = "stamina";
                GiveMeHealth_Print("Secondary Buff set to Stamina");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=sta") then
                TERTIARYbuff = "stamina";
                GiveMeHealth_Print("Tertiary Buff set to Stamina");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b1=str") then
                PRIMARYbuff = "strength";
                GiveMeHealth_Print("Primary Buff set to Strength");
                GMH_Save[Realm][Player].PRIMARYbuff = PRIMARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b2=str") then
                SECONDARYbuff = "strength";
                GiveMeHealth_Print("Secondary Buff set to Strength");
                GMH_Save[Realm][Player].SECONDARYbuff = SECONDARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
        elseif (msg == "b3=str") then
                TERTIARYbuff = "strength";
                GiveMeHealth_Print("Tertiary Buff set to Strength");
                GMH_Save[Realm][Player].TERTIARYbuff = TERTIARYbuff;
                GMB_Go(GMH_BUFFMACRONAME);
                        
        end
	
end


function GiveMeHealth_Print(msg) 
	if ( ( msg ) and ( strlen(msg) > 0 ) ) then
		if ( DEFAULT_CHAT_FRAME ) then
			DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
		end
	end
end

function GiveMeHealth_InitVars()
	Player=UnitName("player");
	Realm=GetCVar("realmName");

	if GMH_Save[Realm] == nil then
		GMH_Save[Realm] = {}
	end

	if GMH_Save[Realm][Player] == nil then
		GMH_Save[Realm][Player] = {}
	end

	if (GMH_Save[Realm][Player].saveType  == nil) then
		GMH_Save[Realm][Player].saveType  = "meat";
		saveType = "meat";
	else
		saveType = GMH_Save[Realm][Player].saveType;
	end
        
        if (GMH_Save[Realm][Player].PRIMARYbuff == nil) then
                GMH_Save[Realm][Player].PRIMARYbuff = "stamina";
                PRIMARYbuff = "stamina";
        else
                PRIMARYbuff = GMH_Save[Realm][Player].PRIMARYbuff;
        end

        if (GMH_Save[Realm][Player].SECONDARYbuff == nil) then
                GMH_Save[Realm][Player].SECONDARYbuff = "spirit";
                SECONDARYbuff = "spirit";
        else
                SECONDARYbuff = GMH_Save[Realm][Player].SECONDARYbuff;
        end

        if (GMH_Save[Realm][Player].TERTIARYbuff == nil) then
                GMH_Save[Realm][Player].TERTIARYbuff = "critical";
                TERTIARYbuff = "critical";
        else
                TERTIARYbuff = GMH_Save[Realm][Player].TERTIARYbuff;
        end

	GiveMeHealth_MakeArray();
	
end

function GiveMeHealth_MakeArray()

	GMH_HPotions = {
                        --Special Location Items:
			[36] = { [1] = HEAL_ARENA_2160, [2] = 0, [3] = 0, [4] = "ARENA", [5] = "ALL" },
			[35] = { [1] = HEAL_TK_2500, [2] = 55, [3] = 0, [4] = "TK", [5] = "ALL" },
			[34] = { [1] = HEAL_BEP_1750_2, [2] = 70, [3] = 0, [4] = "BE", [5] = "ALL" },
			[33] = { [1] = HEAL_BEP_1750, [2] = 70, [3] = 0, [4] = "BE", [5] = "ALL" },
			[32] = { [1] = HEAL_CFR_2500, [2] = 55, [3] = 0, [4] = "CFR", [5] = "ALL" },
			[31] = { [1] = HEAL_1260_P, [2] = 45 , [3] = 0, [4] = "BG", [5] = "ALL" }, 
			[30] = { [1] = HEAL_720_P, [2] = 35, [3] = 0, [4] = "BG", [5] = "ALL" },
			--Normal Items:
			[29] = { [1] = HEAL_4500_I, [2] = 70, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[28] = { [1] = HEAL_4500, [2] = 65, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[27] = { [1] = RJ_4125, [2] = 75, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[26] = { [1] = RJ_2750, [2] = 65, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[25] = { [1] = HEAL_2500_I2, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[24] = { [1] = HEAL_2500_I, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[23] = { [1] = HEAL_2500_5, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[22] = { [1] = HEAL_2500_4, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[21] = { [1] = HEAL_2500_3, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[20] = { [1] = HEAL_2500_2, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[19] = { [1] = HEAL_2500, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[18] = { [1] = HEAL_ARENA_2160, [2] = 0, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[17] = { [1] = RJ_1760, [2] = 50, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[16] = { [1] = HEAL_1750_P4, [2] = 61, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[15] = { [1] = HEAL_1750_P3, [2] = 61, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = HEAL_1750_P2, [2] = 61, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = HEAL_1750_P, [2] = 61, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = HEAL_1750_2, [2] = 55, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = HEAL_1750, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[10] = { [1] = RJ_1500, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[9] = { [1] = HEAL_900_P, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[8] = { [1] = HEAL_900_2, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[7] = { [1] = HEAL_900, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[6] = { [1] = HEAL_585,  [2] = 21, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = HEAL_360, [2] = 12, [3] = 0, [4] = "ALL", [5] = "ALL" }, 
			[4] = { [1] = HEAL_180_2, [2] = 5, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = HEAL_180, [2] = 3, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = RJ_150, [2] = 5, [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = HEAL_90, [2] = 0, [3] = 0, [4] = "ALL", [5] = "ALL" },
	};	
	
	GMH_MPotions = {
                        --Special Location Items:
			[36] = { [1] = MANA_ARENA_600, [2] = 0 , [3] = 0, [4] = "ARENA", [5] = "ALL" },
			[35] = { [1] = MANA_TK_3000, [2] = 55 , [3] = 0, [4] = "TK", [5] = "ALL" },
			[34] = { [1] = MANA_BEP_3000_2, [2] = 70, [3] = 0, [4] = "BE", [5] = "ALL" },
			[33] = { [1] = MANA_BEP_3000, [2] = 70, [3] = 0, [4] = "BE", [5] = "ALL" },
			[32] = { [1] = MANA_CFR_3000, [2] = 55, [3] = 0, [4] = "CFR", [5] = "ALL" },
			[31] = { [1] = MANA_1260_P, [2] = 45 , [3] = 0, [4] = "BG", [5] = "ALL" },
			[30] = { [1] = MANA_720_P, [2] = 35 , [3] = 0,[4] = "BG", [5] = "ALL" },
			--Normal Items:
			[29] = { [1] = MANA_4400_I, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[28] = { [1] = MANA_4400, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[27] = { [1] = RJ_4125, [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[26] = { [1] = MANA_3000_5, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[25] = { [1] = MANA_3000_4, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[24] = { [1] = MANA_3000_3, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[23] = { [1] = MANA_3000_2, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[22] = { [1] = MANA_3000, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[21] = { [1] = RJ_2750, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[20] = { [1] = MANA_2750, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[19] = { [1] = MANA_2500_I2, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[18] = { [1] = MANA_2500_I, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[17] = { [1] = MANA_2250_P4, [2] = 61 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[16] = { [1] = MANA_2250_P3, [2] = 61 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[15] = { [1] = MANA_2250_P2, [2] = 61 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = MANA_2250_P, [2] = 61 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = MANA_2250_2, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = MANA_2250, [2] = 49 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = RJ_1760, [2] = 50 , [3] = 0,[4] = "ALL", [5] = "ALL" },
			[10] = { [1] = RJ_1500, [2] = 35 , [3] = 0,[4] = "ALL", [5] = "ALL" },
			[9] = { [1] = MANA_1500_P, [2] = 41 , [3] = 0,[4] = "ALL", [5] = "ALL" },
			[8] = { [1] = MANA_1500, [2] = 41 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[7] = { [1] = MANA_900, [2] = 31 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[6] = { [1] = MANA_ARENA_600, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = MANA_585, [2] = 22 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[4] = { [1] = MANA_360, [2] = 14 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = MANA_180_2, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = MANA_180, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = RJ_150, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
	};	
	
	GMH_Bandages = {
			--PvP Items
                        [28] = { [1] = BAN_2000_WSG, [2] = 45 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[27] = { [1] = BAN_1104_WSG, [2] = 35 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[26] = { [1] = BAN_640_WSG, [2] = 25 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[25] = { [1] = BAN_2000_AB3, [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[24] = { [1] = BAN_2000_AB2, [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[23] = { [1] = BAN_2000_AB, [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[22] = { [1] = BAN_1104_AB3, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[21] = { [1] = BAN_1104_AB2, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[20] = { [1] = BAN_1104_AB, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[19] = { [1] = BAN_640_AB3, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[18] = { [1] = BAN_640_AB2, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[17] = { [1] = BAN_640_AB, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[16] = { [1] = BAN_2000_AV, [2] = 0 , [3] = 0, [4] = AV, [5] = "ALL" },
			--Normal Items:
			[15] = { [1] = BAN_4100, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = BAN_5800, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = BAN_4800, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = BAN_3400, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = BAN_2800, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[10] = { [1] = BAN_2000, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[9] = { [1] = BAN_1360, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[8] = { [1] = BAN_1104, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[7] = { [1] = BAN_800, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[6] = { [1] = BAN_640, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = BAN_400, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[4] = { [1] = BAN_301, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = BAN_161, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = BAN_114, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = BAN_66, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
	};
	
	GMH_Water = {
			--PvP Water
			[85] = { [1] = VEND_WAT_ARENA_12960, [2] = 75 , [3] = 0, [4] = "ARENA", [5] = "ALL" },
			[84] = { [1] = VEND_WAT_ARENA_7200, [2] = 65 , [3] = 0, [4] = "ARENA", [5] = "ALL" },
			[83] = { [1] = VEND_WAT_ARENA_4200, [2] = 55 , [3] = 0, [4] = "ARENA", [5] = "ALL" },
			[82] = { [1] = VEND_BIS_2148_4410_WSG, [2] = 45 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[81] = { [1] = VEND_BIS_1608_3306_WSG, [2] = 35 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[80] = { [1] = VEND_BIS_1074_2202_WSG, [2] = 25 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[79] = { [1] = VEND_BIS_2148_4410_AB3, [2] = 45 , [3] = 0, [4] =AB, [5] = "ALL" },
			[78] = { [1] = VEND_BIS_2148_4410_AB2, [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[77] = { [1] = VEND_BIS_2148_4410_AB, [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[76] = { [1] = VEND_BIS_1608_3306_AB3, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[75] = { [1] = VEND_BIS_1608_3306_AB2, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[74] = { [1] = VEND_BIS_1608_3306_AB, [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[73] = { [1] = VEND_BIS_1074_2202_AB3, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[72] = { [1] = VEND_BIS_1074_2202_AB2, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[71] = { [1] = VEND_BIS_1074_2202_AB, [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			--Mage Water
			[70] = { [1] = CONJ_BIS_15000_12960, [2] = 80 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[69] = { [1] = CONJ_BIS_13200_9180, [2] = 74 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[68] = { [1] = CONJ_BIS_7500_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[67] = { [1] = CONJ_WAT_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[66] = { [1] = CONJ_WAT_5100, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[65] = { [1] = CONJ_WAT_4200, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[64] = { [1] = CONJ_WAT_2934, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[63] = { [1] = CONJ_WAT_1992, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[62] = { [1] = CONJ_WAT_1345, [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[61] = { [1] = CONJ_WAT_835, [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[60] = { [1] = CONJ_WAT_437, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[59] = { [1] = CONJ_WAT_151, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                        --Biscuits
                        --Drop Water
                        --Cooking
                        --Vendor Water
			[58] = { [1] = COOK_BIS_15000_12960_3, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[57] = { [1] = COOK_BIS_15000_12960_2, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[56] = { [1] = COOK_BIS_15000_12960, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[55] = { [1] = DROP_WAT_12960, [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[54] = { [1] = COOK_WAT_12960, [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[53] = { [1] = VEND_WAT_12960_2, [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[52] = { [1] = VEND_WAT_12960, [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[51] = { [1] = DROP_WAT_9180, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[50] = { [1] = VEND_WAT_9180, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[49] = { [1] = VEND_BIS_5per20, [2] = 40 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[48] = { [1] = COOK_BIS_7500_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[47] = { [1] = VEND_BIS_7500_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[46] = { [1] = DROP_WAT_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[45] = { [1] = VEND_WAT_7200_9, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[44] = { [1] = VEND_WAT_7200_8, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[43] = { [1] = VEND_WAT_7200_7, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[42] = { [1] = VEND_WAT_7200_6, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[41] = { [1] = VEND_WAT_7200_5, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[40] = { [1] = VEND_WAT_7200_4, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[39] = { [1] = VEND_WAT_7200_3, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[38] = { [1] = VEND_WAT_7200_2, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[37] = { [1] = VEND_WAT_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[36] = { [1] = VEND_WAT_ARENA_7200, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[35] = { [1] = VEND_BIS_4per25_3per25, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[34] = { [1] = VEND_BIS_3per25_3, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[33] = { [1] = VEND_BIS_3per25_2, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[32] = { [1] = VEND_BIS_3per25, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[31] = { [1] = VEND_BIS_4320_5100, [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[30] = { [1] = VEND_WAT_5100_4, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[29] = { [1] = VEND_WAT_5100_3, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[28] = { [1] = VEND_WAT_5100_2, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[27] = { [1] = VEND_WAT_5100, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[26] = { [1] = VEND_WAT_2per30_2, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[25] = { [1] = VEND_WAT_2per30, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[24] = { [1] = CONJ_BIS_4410_4410, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[23] = { [1] = VEND_BIS_4410_4410, [2] = 51 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[22] = { [1] = VEND_BIS_4320_4410, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[21] = { [1] = VEND_BIS_2148_4410, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[20] = { [1] = DROP_WAT_4200, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[19] = { [1] = VEND_WAT_ARENA_4200, [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[18] = { [1] = VEND_WAT_2934_3, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[17] = { [1] = VEND_WAT_2934_2, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[16] = { [1] = VEND_WAT_2934, [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[15] = { [1] = VEND_WAT_1992_2, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = VEND_WAT_1992, [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = DROP_WAT_1345, [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = VEND_WAT_1345_3, [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = VEND_WAT_1345_2, [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[10] = { [1] = VEND_WAT_1345, [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[9] = { [1] = VEND_WAT_835_3, [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[8] = { [1] = VEND_WAT_835_2, [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[7] = { [1] = VEND_WAT_835, [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[6] = { [1] = VEND_WAT_437_2, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = VEND_WAT_437, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[4] = { [1] = COOK_BIS_294_294, [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = VEND_BIS_294_294, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = VEND_WAT_151, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = DROP_BIS_30_60, [2] = 4 , [3] = 0, [4] = "ALL", [5] = "ALL" },
	};
        
	GMH_Food = {
			--PvP Food
			[212] = { [1] = VEND_BIS_2148_4410_WSG,         [2] = 45 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[211] = { [1] = VEND_BIS_1608_3306_WSG,         [2] = 35 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[210] = { [1] = VEND_BIS_1074_2202_WSG,         [2] = 25 , [3] = 0, [4] = WSG, [5] = "ALL" },
			[209] = { [1] = VEND_BIS_2148_4410_AB3,         [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[208] = { [1] = VEND_BIS_2148_4410_AB2,         [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[207] = { [1] = VEND_BIS_2148_4410_AB,          [2] = 45 , [3] = 0, [4] = AB, [5] = "ALL" },
			[206] = { [1] = VEND_BIS_1608_3306_AB3,         [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[205] = { [1] = VEND_BIS_1608_3306_AB2,         [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[204] = { [1] = VEND_BIS_1608_3306_AB,          [2] = 35 , [3] = 0, [4] = AB, [5] = "ALL" },
			[203] = { [1] = VEND_BIS_1074_2202_AB3,         [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[202] = { [1] = VEND_BIS_1074_2202_AB2,         [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			[201] = { [1] = VEND_BIS_1074_2202_AB,          [2] = 25 , [3] = 0, [4] = AB, [5] = "ALL" },
			--Mage Food
			[200] = { [1] = CONJ_BIS_15000_12960,   [2] = 80 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[199] = { [1] = CONJ_FOOD_15000_3,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[198] = { [1] = CONJ_FOOD_15000_2,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[197] = { [1] = CONJ_FOOD_15000,        [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[196] = { [1] = CONJ_BIS_13200_9180,    [2] = 74 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[195] = { [1] = CONJ_FOOD_13200,        [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[194] = { [1] = CONJ_BIS_7500_7200,     [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[193] = { [1] = CONJ_FOOD_7500,         [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[192] = { [1] = CONJ_FOOD_4320,         [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[191] = { [1] = CONJ_FOOD_2148,         [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[190] = { [1] = CONJ_FOOD_1392,         [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[189] = { [1] = CONJ_FOOD_874,          [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[188] = { [1] = CONJ_FOOD_552,          [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[187] = { [1] = CONJ_FOOD_243,          [2] = 5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[186] = { [1] = CONJ_FOOD_61,           [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			--Biscuits
                        --Drop
                        --Cooking
                        --Vendor
                       	[185] = { [1] = DROP_FOOD_15000_2,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[184] = { [1] = DROP_FOOD_15000,        [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[183] = { [1] = COOK_BIS_15000_12960_3, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[182] = { [1] = COOK_BIS_15000_12960_2, [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[181] = { [1] = COOK_BIS_15000_12960,   [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[180] = { [1] = COOK_FOOD_15000,        [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[179] = { [1] = VEND_FOOD_15000_14,     [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[178] = { [1] = VEND_FOOD_15000_13,     [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[177] = { [1] = VEND_FOOD_15000_12,     [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[176] = { [1] = VEND_FOOD_15000_11,     [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[175] = { [1] = VEND_FOOD_15000_10,     [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[174] = { [1] = VEND_FOOD_15000_9,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[173] = { [1] = VEND_FOOD_15000_8,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[172] = { [1] = VEND_FOOD_15000_7,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[171] = { [1] = VEND_FOOD_15000_6,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[170] = { [1] = VEND_FOOD_15000_5,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[169] = { [1] = VEND_FOOD_15000_4,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[168] = { [1] = VEND_FOOD_15000_3,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[167] = { [1] = VEND_FOOD_15000_2,      [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[166] = { [1] = VEND_FOOD_15000,        [2] = 75 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[165] = { [1] = DROP_FOOD_13200_6,      [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[164] = { [1] = DROP_FOOD_13200_5,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[163] = { [1] = DROP_FOOD_13200_4,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[162] = { [1] = DROP_FOOD_13200_3,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[161] = { [1] = DROP_FOOD_13200_2,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                       	[160] = { [1] = DROP_FOOD_13200,        [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[159] = { [1] = VEND_FOOD_13200_10,     [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[158] = { [1] = VEND_FOOD_13200_9,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[157] = { [1] = VEND_FOOD_13200_8,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[156] = { [1] = VEND_FOOD_13200_7,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[155] = { [1] = VEND_FOOD_13200_6,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[154] = { [1] = VEND_FOOD_13200_5,      [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[153] = { [1] = VEND_FOOD_13200_4,      [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[152] = { [1] = VEND_FOOD_13200_3,      [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[151] = { [1] = VEND_FOOD_13200_2,      [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[150] = { [1] = VEND_FOOD_13200,        [2] = 70 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[149] = { [1] = VEND_BIS_5per20,        [2] = 40 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[148] = { [1] = COOK_BIS_7500_7200,     [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[147] = { [1] = VEND_BIS_7500_7200,     [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[146] = { [1] = DROP_FOOD_7500,         [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[145] = { [1] = COOK_FOOD_7500,         [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[144] = { [1] = VEND_FOOD_7500_10,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[143] = { [1] = VEND_FOOD_7500_9,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[142] = { [1] = VEND_FOOD_7500_8,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[141] = { [1] = VEND_FOOD_7500_7,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[140] = { [1] = VEND_FOOD_7500_6,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[139] = { [1] = VEND_FOOD_7500_5,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[138] = { [1] = VEND_FOOD_7500_4,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[137] = { [1] = VEND_FOOD_7500_3,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[136] = { [1] = VEND_FOOD_7500_2,       [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[135] = { [1] = VEND_FOOD_7500,         [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[134] = { [1] = VEND_BIS_4per25_3per25, [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[133] = { [1] = VEND_BIS_3per25_3,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[132] = { [1] = VEND_BIS_3per25_2,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[131] = { [1] = VEND_BIS_3per25,        [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[130] = { [1] = CONJ_BIS_4410_4410,     [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[129] = { [1] = VEND_BIS_4410_4410,     [2] = 51 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[128] = { [1] = VEND_BIS_4320_5100,     [2] = 65 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[127] = { [1] = VEND_BIS_4320_4410,     [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[126] = { [1] = DROP_FOOD_4320_8,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[125] = { [1] = DROP_FOOD_4320_7,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[124] = { [1] = DROP_FOOD_4320_6,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[123] = { [1] = DROP_FOOD_4320_5,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[122] = { [1] = DROP_FOOD_4320_4,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[121] = { [1] = DROP_FOOD_4320_3,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[120] = { [1] = DROP_FOOD_4320_2,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
                        [119] = { [1] = DROP_FOOD_4320,         [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[118] = { [1] = COOK_FOOD_4320,         [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[117] = { [1] = VEND_FOOD_4320_7,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[116] = { [1] = VEND_FOOD_4320_6,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[115] = { [1] = VEND_FOOD_4320_5,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[114] = { [1] = VEND_FOOD_4320_4,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[113] = { [1] = VEND_FOOD_4320_3,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[112] = { [1] = VEND_FOOD_4320_2,       [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[111] = { [1] = VEND_FOOD_4320,         [2] = 55 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[110] = { [1] = VEND_BIS_2148_4410,     [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[109] = { [1] = DROP_FOOD_2148_6,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[108] = { [1] = DROP_FOOD_2148_5,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[107] = { [1] = DROP_FOOD_2148_4,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[106] = { [1] = DROP_FOOD_2148_3,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[105] = { [1] = DROP_FOOD_2148_2,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[104] = { [1] = DROP_FOOD_2148,         [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[103] = { [1] = COOK_FOOD_2148_2,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[102] = { [1] = COOK_FOOD_2148,         [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[101] = { [1] = VEND_FOOD_2148_9,       [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[100] = { [1] = VEND_FOOD_2148_8,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[99] = { [1] = VEND_FOOD_2148_7,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[98] = { [1] = VEND_FOOD_2148_6,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[97] = { [1] = VEND_FOOD_2148_5,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[96] = { [1] = VEND_FOOD_2148_4,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[95] = { [1] = VEND_FOOD_2148_3,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[94] = { [1] = VEND_FOOD_2148_2,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[93] = { [1] = VEND_FOOD_2148,          [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[92] = { [1] = VEND_FOOD_2per25_5,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[91] = { [1] = VEND_FOOD_2per25_4,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[90] = { [1] = VEND_FOOD_2per25_3,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[89] = { [1] = VEND_FOOD_2per25_2,      [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[88] = { [1] = VEND_FOOD_2per25,        [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[87] = { [1] = DROP_FOOD_1392_7,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[86] = { [1] = DROP_FOOD_1392_6,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[85] = { [1] = DROP_FOOD_1392_5,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[84] = { [1] = DROP_FOOD_1392_4,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[83] = { [1] = DROP_FOOD_1392_3,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[82] = { [1] = DROP_FOOD_1392_2,        [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[81] = { [1] = DROP_FOOD_1392,          [2] = 45 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[80] = { [1] = COOK_FOOD_1392_3,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[79] = { [1] = COOK_FOOD_1392_2,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[78] = { [1] = COOK_FOOD_1392,          [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[77] = { [1] = VEND_FOOD_1392_8,        [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[76] = { [1] = VEND_FOOD_1392_7,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[75] = { [1] = VEND_FOOD_1392_6,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[74] = { [1] = VEND_FOOD_1392_5,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[73] = { [1] = VEND_FOOD_1392_4,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[72] = { [1] = VEND_FOOD_1392_3,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[71] = { [1] = VEND_FOOD_1392_2,        [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[70] = { [1] = VEND_FOOD_1392,          [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[69] = { [1] = DROP_FOOD_874_6,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[68] = { [1] = DROP_FOOD_874_5,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[67] = { [1] = DROP_FOOD_874_4,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[66] = { [1] = DROP_FOOD_874_3,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[65] = { [1] = DROP_FOOD_874_2,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[64] = { [1] = DROP_FOOD_874,           [2] = 35 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[63] = { [1] = COOK_FOOD_874_2,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[62] = { [1] = COOK_FOOD_874,           [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[61] = { [1] = VEND_FOOD_874_4,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[60] = { [1] = VEND_FOOD_874_3,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[59] = { [1] = VEND_FOOD_874_2,         [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[58] = { [1] = VEND_FOOD_874,           [2] = 25 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[57] = { [1] = DROP_FOOD_552_5,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[56] = { [1] = DROP_FOOD_552_4,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[55] = { [1] = DROP_FOOD_552_3,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[54] = { [1] = DROP_FOOD_552_2,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[53] = { [1] = DROP_FOOD_552,           [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[52] = { [1] = COOK_FOOD_552_5,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[51] = { [1] = COOK_FOOD_552_4,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[50] = { [1] = COOK_FOOD_552_3,         [2] = 10 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[49] = { [1] = COOK_FOOD_552_2,         [2] = 10 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[48] = { [1] = COOK_FOOD_552,           [2] = 10 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[47] = { [1] = VEND_FOOD_552_3,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[46] = { [1] = VEND_FOOD_552_2,         [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[45] = { [1] = VEND_FOOD_552,           [2] = 15 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[44] = { [1] = COOK_BIS_294_294,        [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[43] = { [1] = VEND_BIS_294_294,        [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[42] = { [1] = DROP_FOOD_243_6,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[41] = { [1] = DROP_FOOD_243_5,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[40] = { [1] = DROP_FOOD_243_4,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[39] = { [1] = DROP_FOOD_243_3,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[38] = { [1] = DROP_FOOD_243_2,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[37] = { [1] = DROP_FOOD_243,           [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[36] = { [1] = COOK_FOOD_243_4,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[35] = { [1] = COOK_FOOD_243_3,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[34] = { [1] = COOK_FOOD_243_2,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[33] = { [1] = COOK_FOOD_243,           [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[32] = { [1] = VEND_FOOD_243_8,         [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[31] = { [1] = VEND_FOOD_243_7,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[30] = { [1] = VEND_FOOD_243_6,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[29] = { [1] = VEND_FOOD_243_5,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[28] = { [1] = VEND_FOOD_243_4,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[27] = { [1] = VEND_FOOD_243_3,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[26] = { [1] = VEND_FOOD_243_2,         [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[25] = { [1] = VEND_FOOD_243,           [2] =  5 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[24] = { [1] = DROP_FOOD_61_8,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[23] = { [1] = DROP_FOOD_61_7,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[22] = { [1] = DROP_FOOD_61_6,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[21] = { [1] = DROP_FOOD_61_5,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[20] = { [1] = DROP_FOOD_61_4,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[19] = { [1] = DROP_FOOD_61_3,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[18] = { [1] = DROP_FOOD_61_2,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[17] = { [1] = DROP_FOOD_61,            [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[16] = { [1] = COOK_FOOD_61_4,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[15] = { [1] = COOK_FOOD_61_3,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = COOK_FOOD_61_2,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = COOK_FOOD_61,            [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = VEND_FOOD_61_8,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = VEND_FOOD_61_7,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[10] = { [1] = VEND_FOOD_61_6,          [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[9] = { [1] = VEND_FOOD_61_5,           [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[8] = { [1] = VEND_FOOD_61_4,           [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[7] = { [1] = VEND_FOOD_61_3,           [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[6] = { [1] = VEND_FOOD_61_2,           [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = VEND_FOOD_61,             [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[4] = { [1] = DROP_BIS_30_60,           [2] =  4 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = DROP_FOOD_30,             [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = VEND_FOOD_30_2,           [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = VEND_FOOD_30,             [2] =  0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
	};
        
	GMH_Stones = {
			[25] = { [1] = HS_5136, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[24] = { [1] = HS_4708, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[23] = { [1] = HS_4280, [2] = 69 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[22] = { [1] = HS_4200, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[21] = { [1] = HS_3850, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[20] = { [1] = HS_3500, [2] = 63 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[19] = { [1] = HS_2496, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[18] = { [1] = HS_2288, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[17] = { [1] = HS_2080, [2] = 60 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[16] = { [1] = HS_2000, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[15] = { [1] = HS_1440, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[14] = { [1] = HS_1320, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[13] = { [1] = HS_1200, [2] = 48 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[12] = { [1] = HS_960, [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[11] = { [1] = HS_880, [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[10] = { [1] = HS_800, [2] = 36 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[9] = { [1] = HS_600, [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[8] = { [1] = HS_550, [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[7] = { [1] = HS_500, [2] = 24 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[6] = { [1] = HS_300, [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[5] = { [1] = HS_275, [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[4] = { [1] = HS_250, [2] = 12 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[3] = { [1] = HS_120, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[2] = { [1] = HS_110, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
			[1] = { [1] = HS_100, [2] = 0 , [3] = 0, [4] = "ALL", [5] = "ALL" },
	};
        
        GMH_Buff = {
			--oth
                        [141]   = { [1] = BUFF_OTH_ZAP,                     [2] = 55, [3] = OTH, [4] = NON },
                        [140]   = { [1] = BUFF_OTH_FIRE,                    [2] = 35, [3] = OTH, [4] = NON },
                        [139]   = { [1] = BUFF_OTH_RAND_2,                  [2] = 0, [3] = OTH, [4] = NON },
                        [138]   = { [1] = BUFF_OTH_RAND,                    [2] = 0, [3] = OTH, [4] = NON },
                        [137]   = { [1] = BUFF_OTH_SAD,                     [2] = 0, [3] = OTH, [4] = NON },
                        [136]   = { [1] = BUFF_OTH_HAPPY_2,                 [2] = 0, [3] = OTH, [4] = NON },
                        [135]   = { [1] = BUFF_OTH_HAPPY,                   [2] = 0, [3] = OTH, [4] = NON },
                        [134]   = { [1] = BUFF_OTH_FISH,                    [2] = 0, [3] = OTH, [4] = NON },
                        [133]   = { [1] = BUFF_OTH_BIS_15000_12960_TRK_BST, [2] = 70, [3] = OTH, [4] = NON },
                        [132]   = { [1] = BUFF_OTH_15000_TRK_HUM,           [2] = 70, [3] = OTH, [4] = NON },
                        [131]   = { [1] = BUFF_OTH_7500_FORTUNE,            [2] = 65, [3] = OTH, [4] = NON },
                        --sta/mp5
			[130]   = { [1] = BUFF_BIS_15000_12960_STA_40_MP5_16, [2] = 70, [3] = STA, [4] = MP5 },
			[129]   = { [1] = BUFF_15000_STA_40_MP5_16,           [2] = 70, [3] = STA, [4] = MP5 },
			[128]   = { [1] = BUFF_BIS_15000_12960_STA_40_MP5_12, [2] = 70, [3] = STA, [4] = MP5 },
                        --sta/spi
                        [127]   = { [1] = BUFF_15000_STA_40_SPI_40, [2] = 70, [3] = STA, [4] = SPI },
                        --arm/sta
                        [126]   = { [1] = BUFF_15000_ARM_40_STA_40, [2] = 70, [3] = ARM, [4] = STA },
                        --agi/sta
                        [125]   = { [1] = BUFF_BIS_15000_12960_AGI_40_STA_40, [2] = 70, [3] = AGI, [4] = STA },
                        --atk/sta
                        [124]   = { [1] = BUFF_BIS_15000_12960_ATK_80_STA_40, [2] = 70, [3] = ATK, [4] = STA },
                        [123]   = { [1] = BUFF_15000_ATK_80_STA_40,           [2] = 70, [3] = ATK, [4] = STA },
                        [122]   = { [1] = BUFF_BIS_15000_12960_ATK_60_STA_40, [2] = 70, [3] = ATK, [4] = STA },
                        --exp/sta
                        [121]   = { [1] = BUFF_15000_EXP_40_STA_40, [2] = 70, [3] = EXP, [4] = STA },
                        --str/sta
                        [120]   = { [1] = BUFF_15000_STR_40_STA_40, [2] = 70, [3] = STR, [4] = STA },
                        --hit/sta
                        [119]   = { [1] = BUFF_BIS_15000_12960_HIT_40_STA_40, [2] = 70, [3] = HIT, [4] = STA },
                        --spl/sta
                        [118]   = { [1] = BUFF_BIS_15000_12960_SPL_46_STA_40, [2] = 70, [3] = SPL, [4] = STA },
                        [117]   = { [1] = BUFF_15000_SPL_46_STA_40,           [2] = 70, [3] = SPL, [4] = STA },
                        [116]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_40, [2] = 70, [3] = SPL, [4] = STA },
                        --has/sta
                        [115]   = { [1] = BUFF_BIS_15000_12960_HAS_40_STA_40, [2] = 70, [3] = HAS, [4] = STA },
                        [114]   = { [1] = BUFF_15000_HAS_40_STA_40,           [2] = 70, [3] = HAS, [4] = STA },
                        [113]   = { [1] = BUFF_15000_HAS_30_STA_40,           [2] = 70, [3] = HAS, [4] = STA },
                        --crt/sta
			[112]   = { [1] = BUFF_BIS_15000_12960_CRT_40_STA_40, [2] = 70, [3] = CRT, [4] = STA },
			[111]   = { [1] = BUFF_15000_CRT_40_STA_40,           [2] = 70, [3] = CRT, [4] = STA },
                        [110]   = { [1] = BUFF_BIS_15000_12960_CRT_30_STA_40, [2] = 70, [3] = CRT, [4] = STA },
			[109]   = { [1] = BUFF_15000_CRT_30_STA_30_2,         [2] = 70, [3] = CRT, [4] = STA },
			[108]   = { [1] = BUFF_15000_CRT_30_STA_30,           [2] = 70, [3] = CRT, [4] = STA },
			--atk/sta
                        [107]   = { [1] = BUFF_15000_ATK_60_STA_30, [2] = 70, [3] = ATK, [4] = STA },
                        --spl/sta
                        [106]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_30,   [2] = 70, [3] = SPL, [4] = STA },
                        [105]   = { [1] = BUFF_BIS_15000_12960_SPL_35_STA_30_2, [2] = 70, [3] = SPL, [4] = STA },
			--has/sta
			[104]   = { [1] = BUFF_15000_HAS_30_STA_30_2, [2] = 70, [3] = HAS, [4] = STA },
			[103]   = { [1] = BUFF_15000_HAS_30_STA_30,   [2] = 70, [3] = HAS, [4] = STA },
			--sta/mp5
			[102]   = { [1] = BUFF_15000_STA_30_MP5_12, [2] = 70, [3] = STA, [4] = MP5 },
                        --sta/spi
                        [101]   = { [1] = BUFF_13200_STA_25_SPI_25,  [2] = 75, [3] = STA, [4] = SPI },
                        [100]   = { [1] = BUFF_7500_STA_30_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
                        [99]   = { [1] = BUFF_7500_STA_30_SPI_20,   [2] = 65, [3] = STA, [4] = SPI },
                        --crt/spi
                        [98]   = { [1] = BUFF_7200M_CRT_20_SPI_30, [2] = 65, [3] = CRT, [4] = SPI },
                        --sta
                        [97]   = { [1] = BUFF_4320_STA_25, [2] = 55, [3] = STA, [4] = NON },
                        --atk/spi
                        [96]   = { [1] = BUFF_4320_ATK_40_SPI_20, [2] = 55, [3] = ATK, [4] = SPI },
                        --hit/spi
                        [95]   = { [1] = BUFF_7500_HIT_20_SPI_20, [2] = 65, [3] = HIT, [4] = SPI },
                        --spl/spi
                        [94]   = { [1] = BUFF_7500_SPL_23_SPI_20_6, [2] = 55, [3] = SPL, [4] = SPI },
                        [93]   = { [1] = BUFF_7500_SPL_23_SPI_20_5, [2] = 55, [3] = SPL, [4] = SPI },
                        [92]   = { [1] = BUFF_7500_SPL_23_SPI_20_4, [2] = 55, [3] = SPL, [4] = SPI },
                        [91]   = { [1] = BUFF_7500_SPL_23_SPI_20_3, [2] = 65, [3] = SPL, [4] = SPI },
                        [90]   = { [1] = BUFF_7500_SPL_23_SPI_20_2, [2] = 65, [3] = SPL, [4] = SPI },
                        [89]   = { [1] = BUFF_7500_SPL_23_SPI_20,   [2] = 55, [3] = SPL, [4] = SPI },
                        --agi/spi
                        [88]   = { [1] = BUFF_7500_AGI_20_SPI_20_3, [2] = 55, [3] = AGI, [4] = SPI },
                        [87]   = { [1] = BUFF_7500_AGI_20_SPI_20_2, [2] = 65, [3] = AGI, [4] = SPI },
                        [86]   = { [1] = BUFF_7500_AGI_20_SPI_20,   [2] = 55, [3] = AGI, [4] = SPI },
                        --sta/spi
                        [85]   = { [1] = BUFF_7500_STA_20_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
			[84]   = { [1] = BUFF_7500_STA_20_SPI_20,   [2] = 55, [3] = STA, [4] = SPI },
			[83]   = { [1] = BUFF_7200M_STA_20_SPI_20,  [2] = 65, [3] = STA, [4] = SPI },
			[82]   = { [1] = BUFF_4320_STA_20_SPI_20_3, [2] = 55, [3] = STA, [4] = SPI },
			[81]   = { [1] = BUFF_4320_STA_20_SPI_20_2, [2] = 55, [3] = STA, [4] = SPI },
			[80]   = { [1] = BUFF_4320_STA_20_SPI_20,   [2] = 55, [3] = STA, [4] = SPI },
			--sta/mp5
			[79]   = { [1] = BUFF_4320_STA_20_MP5_8, [2] = 55, [3] = STA, [4] = MP5 },
                        --str/spi
                        [78]   = { [1] = BUFF_7500_STR_20_SPI_20_2, [2] = 55, [3] = STR, [4] = SPI },
                        [77]   = { [1] = BUFF_7500_STR_20_SPI_20,   [2] = 65, [3] = STR, [4] = SPI },
                        --sta/spi
                        [76]   = { [1] = BUFF_6000_STA_15_SPI_15,   [2] = 55, [3] = STA, [4] = SPI },
                        [75]   = { [1] = BUFF_1392_STA_12_SPI_12_6, [2] = 40, [3] = STA, [4] = SPI },
                        [74]   = { [1] = BUFF_1392_STA_12_SPI_12_5, [2] = 35, [3] = STA, [4] = SPI },
                        [73]   = { [1] = BUFF_1392_STA_12_SPI_12_4, [2] = 40, [3] = STA, [4] = SPI },
                        [72]   = { [1] = BUFF_1392_STA_12_SPI_12_3, [2] = 40, [3] = STA, [4] = SPI },
                        [71]   = { [1] = BUFF_1392_STA_12_SPI_12_2, [2] = 35, [3] = STA, [4] = SPI },
                        [70]   = { [1] = BUFF_1392_STA_12_SPI_12, [2] = 40, [3] = STA, [4] = SPI },
                        --sta
                        [69]   = { [1] = BUFF_4320_STA_10_4, [2] = 35, [3] = STA, [4] = NON },
                        [68]   = { [1] = BUFF_4320_STA_10_3, [2] = 55, [3] = STA, [4] = NON },
                        [67]   = { [1] = BUFF_4320_STA_10_2, [2] = 55, [3] = STA, [4] = NON },
                        [66]   = { [1] = BUFF_4320_STA_10,   [2] = 45, [3] = STA, [4] = NON },
                        [65]   = { [1] = BUFF_874_STA_10,    [2] = 55, [3] = STA, [4] = NON },
                        --spi
                        [64]   = { [1] = BUFF_4320_SPI_10, [2] = 55, [3] = SPI, [4] = NON },
                        [63]   = { [1] = BUFF_874_SPI_10,  [2] = 35, [3] = SPI, [4] = NON },
                        --sta/spi
                        [62]   = { [1] = BUFF_874_STA_8_SPI_8_10, [2] = 20, [3] = STA, [4] = SPI },
                        [61]   = { [1] = BUFF_874_STA_8_SPI_8_9,  [2] = 25, [3] = STA, [4] = SPI },
                        [60]   = { [1] = BUFF_874_STA_8_SPI_8_8,  [2] = 25, [3] = STA, [4] = SPI },
                        [59]   = { [1] = BUFF_874_STA_8_SPI_8_7,  [2] = 25, [3] = STA, [4] = SPI },
                        [58]   = { [1] = BUFF_874_STA_8_SPI_8_6,  [2] = 25, [3] = STA, [4] = SPI },
                        [57]   = { [1] = BUFF_874_STA_8_SPI_8_5,  [2] = 25, [3] = STA, [4] = SPI },
                        [56]   = { [1] = BUFF_874_STA_8_SPI_8_4,  [2] = 20, [3] = STA, [4] = SPI },
                        [55]   = { [1] = BUFF_874_STA_8_SPI_8_3,  [2] = 25, [3] = STA, [4] = SPI },
                        [54]   = { [1] = BUFF_874_STA_8_SPI_8_2,  [2] = 25, [3] = STA, [4] = SPI },
                        [53]   = { [1] = BUFF_874_STA_8_SPI_8,    [2] = 25, [3] = STA, [4] = SPI },
                        [52]   = { [1] = BUFF_552_STA_6_SPI_6_12, [2] = 10, [3] = STA, [4] = SPI },
                        [51]   = { [1] = BUFF_552_STA_6_SPI_6_11, [2] = 10, [3] = STA, [4] = SPI },
                        [50]   = { [1] = BUFF_552_STA_6_SPI_6_10, [2] = 15, [3] = STA, [4] = SPI },
                        [49]   = { [1] = BUFF_552_STA_6_SPI_6_9,  [2] = 15, [3] = STA, [4] = SPI },
                        [48]   = { [1] = BUFF_552_STA_6_SPI_6_8,  [2] = 15, [3] = STA, [4] = SPI },
                        [47]   = { [1] = BUFF_552_STA_6_SPI_6_7,  [2] = 15, [3] = STA, [4] = SPI },
                        [46]   = { [1] = BUFF_552_STA_6_SPI_6_6,  [2] = 15, [3] = STA, [4] = SPI },
                        [45]   = { [1] = BUFF_552_STA_6_SPI_6_5,  [2] = 15, [3] = STA, [4] = SPI },
                        [44]   = { [1] = BUFF_552_STA_6_SPI_6_4,  [2] = 15, [3] = STA, [4] = SPI },
                        [43]   = { [1] = BUFF_552_STA_6_SPI_6_3,  [2] = 15, [3] = STA, [4] = SPI },
                        [42]   = { [1] = BUFF_552_STA_6_SPI_6_2,  [2] = 12, [3] = STA, [4] = SPI },
                        [41]   = { [1] = BUFF_552_STA_6_SPI_6,    [2] = 15, [3] = STA, [4] = SPI },
                        [40]   = { [1] = BUFF_243_STA_4_SPI_4_11, [2] = 5, [3] = STA, [4] = SPI },
                        [39]   = { [1] = BUFF_243_STA_4_SPI_4_10, [2] = 5, [3] = STA, [4] = SPI },
                        [38]   = { [1] = BUFF_243_STA_4_SPI_4_9,  [2] = 5, [3] = STA, [4] = SPI },
                        [37]   = { [1] = BUFF_243_STA_4_SPI_4_8,  [2] = 5, [3] = STA, [4] = SPI },
                        [36]   = { [1] = BUFF_243_STA_4_SPI_4_7,  [2] = 5, [3] = STA, [4] = SPI },
                        [35]   = { [1] = BUFF_243_STA_4_SPI_4_6,  [2] = 5, [3] = STA, [4] = SPI },
                        [34]   = { [1] = BUFF_243_STA_4_SPI_4_5,  [2] = 5, [3] = STA, [4] = SPI },
                        [33]   = { [1] = BUFF_243_STA_4_SPI_4_4,  [2] = 5, [3] = STA, [4] = SPI },
                        [32]   = { [1] = BUFF_243_STA_4_SPI_4_3,  [2] = 5, [3] = STA, [4] = SPI },
                        [31]   = { [1] = BUFF_243_STA_4_SPI_4_2,  [2] = 5, [3] = STA, [4] = SPI },
                        [30]   = { [1] = BUFF_243_STA_4_SPI_4,    [2] = 5, [3] = STA, [4] = SPI },
                        [29]   = { [1] = BUFF_61_STA_2_SPI_2_15,  [2] = 0, [3] = STA, [4] = SPI },
                        [28]   = { [1] = BUFF_61_STA_2_SPI_2_14,  [2] = 0, [3] = STA, [4] = SPI },
                        [27]   = { [1] = BUFF_61_STA_2_SPI_2_13,  [2] = 0, [3] = STA, [4] = SPI },
                        [26]   = { [1] = BUFF_61_STA_2_SPI_2_12,  [2] = 0, [3] = STA, [4] = SPI },
                        [25]   = { [1] = BUFF_61_STA_2_SPI_2_11,  [2] = 0, [3] = STA, [4] = SPI },
                        [24]   = { [1] = BUFF_61_STA_2_SPI_2_10,  [2] = 0, [3] = STA, [4] = SPI },
                        [23]   = { [1] = BUFF_61_STA_2_SPI_2_9,   [2] = 0, [3] = STA, [4] = SPI },
                        [22]   = { [1] = BUFF_61_STA_2_SPI_2_8,   [2] = 0, [3] = STA, [4] = SPI },
                        [21]    = { [1] = BUFF_61_STA_2_SPI_2_7,   [2] = 0, [3] = STA, [4] = SPI },
                        [20]    = { [1] = BUFF_61_STA_2_SPI_2_6,   [2] = 0, [3] = STA, [4] = SPI },
                        [19]    = { [1] = BUFF_61_STA_2_SPI_2_5,   [2] = 0, [3] = STA, [4] = SPI },
                        [18]    = { [1] = BUFF_61_STA_2_SPI_2_4,   [2] = 0, [3] = STA, [4] = SPI },
                        [17]    = { [1] = BUFF_61_STA_2_SPI_2_3,   [2] = 0, [3] = STA, [4] = SPI },
                        [16]    = { [1] = BUFF_61_STA_2_SPI_2_2,   [2] = 0, [3] = STA, [4] = SPI },
                        [15]    = { [1] = BUFF_61_STA_2_SPI_2,     [2] = 0, [3] = STA, [4] = SPI },
                        [14]    = { [1] = BUFF_2per24_STA_SPI_2,   [2] = 0, [3] = STA, [4] = SPI },
                        [13]    = { [1] = BUFF_2per24_STA_SPI,     [2] = 0, [3] = STA, [4] = SPI },
                        --str
                        [12]   = { [1] = BUFF_2148_STR_20_2, [2] = 45, [3] = STR, [4] = NON },
                        [11]   = { [1] = BUFF_2148_STR_20,   [2] = 55, [3] = STR, [4] = NON },
                        [10]   = { [1] = BUFF_1933_STR_10,   [2] = 45, [3] = STR, [4] = NON },
                        --spl
                        [9]   = { [1] = BUFF_1933_SPL_14, [2] = 45, [3] = SPL, [4] = NON },
                        --res
                        [8]   = { [1] = BUFF_4320_RES_8, [2] = 55, [3] = RES, [4] = NON },
                        --mp5
                        [7]   = { [1] = BUFF_874_MP5_8,          [2] = 35, [3] = MP5, [4] = NON },
                        [6]   = { [1] = BUFF_BIS_840_1260_MP5_6, [2] = 30, [3] = MP5, [4] = NON },
                        [5]   = { [1] = BUFF_378_MP5_3,          [2] = 10, [3] = MP5, [4] = NON },
                        --int
                        [4]   = { [1] = BUFF_1933_INT_10, [2] = 45, [3] = INT, [4] = NON },
                        --hp5
                        [3]   = { [1] = BUFF_874_HP5_6, [2] = 35, [3] = HP5, [4] = NON },
                        --atk
                        [2]   = { [1] = BUFF_1933_ATK_24, [2] = 45, [3] = ATK, [4] = NON },
                        --agi
                        [1]   = { [1] = BUFF_874_AGI_10, [2] = 35, [3] = AGI, [4] = NON },
        };
                    
	
end

function GMR_Go(macroName, dontuse)
	local fNum = 0;
	local fBagNum = 0;
	local fSlotNum = 0;
	local fName = "";
	local fIcon = "";
	local fBNum = 0;
	local fBackup = "";
	
	GiveMeHealth_GetZoneType()		

        --GiveMeHealth_Print("Entering "..GHM_ZoneName);

	if (macroName == GMH_BANDAGEMACRONAME) then
		fName = "No bandages";
		TempArray = GMH_Bandages;
	elseif (macroName == GMH_FOODMACRONAME) then
		fName = "No food";
		TempArray = GMH_Food;
	elseif (macroName == GMH_WATERMACRONAME) then
		fName = "No drinks";
		TempArray = GMH_Water;
	elseif (macroName == GMH_HEALTHSTONENAME) then
		fName = "No Stones";
		TempArray = GMH_Stones;
	end
	
	local tHCnt = 0;
	for lttcnt = 1, table.getn(TempArray), 1 do
		TempArray[lttcnt][3] = 0;
	end
	-- Loop through bags.
	for bagID = 0, 4, 1 do
		local cnt = GetContainerNumSlots(bagID);
		if ( cnt > 0 ) then
			-- Loop through slots.
			for slot = 1,cnt,1 do
				local link = GetContainerItemLink(bagID, slot);
	  			local itemnumber = GiveMeHealth_NameFromLink(link);
				--local name = GetItemInfo(GetContainerItemLink(bagID, slot))
				local cntitem,icnt = GetContainerItemInfo(bagID,slot);
				local canuse = false;
				if ( itemnumber ) then
                                        --GiveMeHealth_Print("Found ".. link);
					--GiveMeHealth_Print("Looking at ".. itemnumber);
					
					for lttcnt = 1, table.getn(TempArray), 1 do
                                                if (TempArray[lttcnt][1] == itemnumber) then 
                                                        if ( TempArray[lttcnt][2] <= UnitLevel("player") ) then
                                                                if ( TempArray[lttcnt][5] == "ALL") then
                                                                        if ( TempArray[lttcnt][4] == "ALL" ) then
                                                                                canuse = true;
                                                                        elseif ( TempArray[lttcnt][4] == GHM_ZoneType ) then
                                                                                canuse = true;
                                                                        elseif ( TempArray[lttcnt][4] == GHM_ZoneName ) then
                                                                                canuse = true;
                                                                        end 
								
                                                                        if ( canuse == true ) then
                                                                                TempArray[lttcnt][3] = TempArray[lttcnt][3] + 1;
                                                                                --GiveMeHealth_Print("lttcnt at ".. lttcnt);
                                                                                --GiveMeHealth_Print("fNum ".. fNum);

                                                                                if ( lttcnt > fNum ) then
                                                                                        --GiveMeHealth_Print("Replacing fNum ".. fNum.." with lttcnt ".. lttcnt);
                                                                                        --GiveMeHealth_Print("Replacing fName ".. fName.." with itemnumber ".. itemnumber);
                                                                                        --GiveMeHealth_Print("Replacing Backup fBNum ".. fBNum.." with fNum ".. fNum);
                                                                                        --GiveMeHealth_Print("Replacing Backup fBackup ".. fBackup.." with fName ".. fName);
                                                                                        fBNum = fNum;
                                                                                        fNum = lttcnt;
                                                                                        fBagNum = bagID;
                                                                                        fSlotNum = slot;
                                                                                        fBackup = fName;
                                                                                        fName = itemnumber;
                                                                                        fIcon = cntitem;
                                                                                elseif ( (lttcnt > fBNum)  and (lttcnt < fNum)) then
                                                                                        --GiveMeHealth_Print("2Replacing fBNum ".. fBNum.." with lttcnt ".. lttcnt);
                                                                                        --GiveMeHealth_Print("2Replacing fBackup ".. fBackup.." with itemnumber ".. itemnumber);
                                                                                        fBNum = lttcnt;
                                                                                        fBackup = itemnumber;
										end
									end
									tHCnt =  tHCnt + icnt;
								end
							end
						end	
						
					end			
					
				end
				
			end
		end
		
	end
	
	GMH_PotionCnt[macroName] = tHCnt;
		
	if ( dontuse == true ) then
		if ( fNum > 0 ) then
			return fName, fIcon;
		end 
		return fName, nil;
		
	elseif ( fNum > 0 ) then
		
		--UseContainerItem(fBagNum,fSlotNum);
		if (macroName == GMH_BANDAGEMACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_BANDAGEMACRONAME] == nil) or (GMH_LastItem[GMH_BANDAGEMACRONAME] ~= fName) then
				--GiveMeHealth_Print("Preping/Using "..fName);
				EditMacro(GMH_BANDAGEMACRONAME,GMH_BANDAGEMACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fName..";[mod:ctrl] "..FAID.."\n/gmh update=bandage\n/use [nomod] item:"..fName..";\n/cast [mod:ctrl] "..FAID.."\n/use [modifier:alt, target=player] item:"..fName.." ",true);
				GMH_LastItem[GMH_BANDAGEMACRONAME] = fName;
				GMH_LastBackup[GMH_BANDAGEMACRONAME] = fBackup;
			end
		elseif (macroName == GMH_FOODMACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_FOODMACRONAME] == nil or GMH_LastBackup[GMH_FOODMACRONAME] == nil) or (GMH_LastItem[GMH_FOODMACRONAME] ~= fName or GMH_LastBackup[GMH_FOODMACRONAME] ~= fBackup) then
				--GiveMeHealth_Print("Eating "..fName);
				EditMacro(GMH_FOODMACRONAME,GMH_FOODMACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";[mod:ctrl] "..COOK.."\n/gmh update=food\n/use [button:1, nomod] item:"..fName..";[mod:shift] item:"..fBackup..";\n/cast [button:1, mod:ctrl] "..COOK.."\n/cast [button:2] "..CONJF.." ",true);
				GMH_LastItem[GMH_FOODMACRONAME] = fName;
				GMH_LastBackup[GMH_FOODMACRONAME] = fBackup;
			end
		elseif (macroName == GMH_WATERMACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_WATERMACRONAME] == nil or GMH_LastBackup[GMH_WATERMACRONAME] == nil) or (GMH_LastItem[GMH_WATERMACRONAME] ~= fName or GMH_LastBackup[GMH_WATERMACRONAME] ~= fBackup) then
				--GiveMeHealth_Print("Drinking "..fName.." or " ..fBackup);
				EditMacro(GMH_WATERMACRONAME,GMH_WATERMACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";[mod:ctrl] item:"..fName.."\n/gmh update=water\n/use [button:1, nomod] item:"..fName..";[mod:shift] item:"..fBackup..";\n/cast [button:2] "..CONJW.." ",true);
				GMH_LastItem[GMH_WATERMACRONAME] = fName;
				GMH_LastBackup[GMH_WATERMACRONAME] = fBackup;
			end
		elseif (macroName == GMH_HEALTHSTONENAME and notInCombat) then
			if (GMH_LastItem[GMH_HEALTHSTONENAME] == nil) or (GMH_LastItem[GMH_HEALTHSTONENAME] ~= fName) then
				EditMacro(GMH_HEALTHSTONENAME,GMH_HEALTHSTONENAME,1,"#showtooltip\n/gmh update=stone\n/use [button:1] item:"..fName.."\n/cast [button:2] "..CHS.." ",true);
				GMH_LastItem[GMH_HEALTHSTONENAME] = fName;
				GMH_LastBackup[GMH_HEALTHSTONENAME] = fBackup;
			end
		end 
		
		return fName, fIcon;
	else
		if (macroName == GMH_BANDAGEMACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Bandages");
			EditMacro(GMH_BANDAGEMACRONAME,GMH_BANDAGEMACRONAME,734,"/gmh update=bandage\n/cast [mod:ctrl] "..FAID.." ",0);
			GMH_LastItem[GMH_BANDAGEMACRONAME] = nil;
			GMH_LastBackup[GMH_BANDAGEMACRONAME] = nil;
		elseif (macroName == GMH_FOODMACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Food");
			EditMacro(GMH_FOODMACRONAME,GMH_FOODMACRONAME,775,"/gmh update=food\n/cast [mod:ctrl] "..COOK.."\n/cast [button:2] "..CONJF.." ",0);
			GMH_LastItem[GMH_FOODMACRONAME] = nil;
			GMH_LastBackup[GMH_FOODMACRONAME] = nil;
		elseif (macroName == GMH_WATERMACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Drinks");
			EditMacro(GMH_WATERMACRONAME,GMH_WATERMACRONAME,770,"/gmh update=water\n/cast [button:2] "..CONJW.." ",0);
			GMH_LastItem[GMH_WATERMACRONAME] = nil;
			GMH_LastBackup[GMH_WATERMACRONAME] = nil;
		elseif (macroName == GMH_HEALTHSTONENAME and notInCombat) then
			EditMacro(GMH_HEALTHSTONENAME,GMH_HEALTHSTONENAME,805,"/gmh update=stone\n/cast [button:2] "..CHS.." ",0);
			GMH_LastItem[GMH_HEALTHSTONENAME] = nil;
			GMH_LastBackup[GMH_HEALTHSTONENAME] = nil;
		end 
		
		return fName, nil;
	end
		
end

function GMH_Go(macroName, dontuse)
	local fNum = 0;
	local fBagNum = 0;
	local fSlotNum = 0;
	local fName = "";
	local fIcon = "";
	local fBNum = 0;
	local fBackup = "";
	
	GiveMeHealth_GetZoneType()		

        --GiveMeHealth_Print("Entering "..GHM_ZoneName);

	if (macroName == GMH_MACRONAME) then
		fName = "No health potions";
		TempArray = GMH_HPotions;
	elseif (macroName == GMH_MANAMACRONAME) then
		fName = "No mana potions";
		TempArray = GMH_MPotions;
	end
	
	local tHCnt = 0;
	for lttcnt = 1, table.getn(TempArray), 1 do
		TempArray[lttcnt][3] = 0;
	end
	-- Loop through bags.
	for bagID = 0, 4, 1 do
		local cnt = GetContainerNumSlots(bagID);
		if ( cnt > 0 ) then
			-- Loop through slots.
			for slot = 1,cnt,1 do
				local link = GetContainerItemLink(bagID, slot);
	  			local itemnumber = GiveMeHealth_NameFromLink(link);
				--local name = GetItemInfo(GetContainerItemLink(bagID, slot))
				local cntitem,icnt = GetContainerItemInfo(bagID,slot);
				local canuse = false;
				if ( itemnumber ) then
                                        --GiveMeHealth_Print("Found ".. link);
					--GiveMeHealth_Print("Looking at ".. itemnumber);
					
					for lttcnt = 1, table.getn(TempArray), 1 do
                                                if ( ((TempArray[lttcnt][1] == itemnumber) and (lttcnt < 36)) or ((TempArray[lttcnt][1] == itemnumber) and (GHM_ZoneType == "ARENA"))) then 
                                                        if ( TempArray[lttcnt][2] <= UnitLevel("player") ) then
                                                                if ( TempArray[lttcnt][5] == "ALL") then
                                                                        if ( TempArray[lttcnt][4] == "ALL" ) then
                                                                                canuse = true;
                                                                        elseif ( TempArray[lttcnt][4] == GHM_ZoneType ) then
                                                                                canuse = true;
                                                                        elseif ( TempArray[lttcnt][4] == GHM_ZoneName ) then
                                                                                canuse = true;
                                                                        end 
								
                                                                        if ( canuse == true ) then
                                                                                TempArray[lttcnt][3] = TempArray[lttcnt][3] + 1;
                                                                                --GiveMeHealth_Print("lttcnt at ".. lttcnt);
                                                                                --GiveMeHealth_Print("fNum ".. fNum);

                                                                                if ( lttcnt > fNum ) then
                                                                                        --GiveMeHealth_Print("Replacing fNum ".. fNum.." with lttcnt ".. lttcnt);
                                                                                        --GiveMeHealth_Print("Replacing fName ".. fName.." with itemnumber ".. itemnumber);
                                                                                        --GiveMeHealth_Print("Replacing Backup fBNum ".. fBNum.." with fNum ".. fNum);
                                                                                        --GiveMeHealth_Print("Replacing Backup fBackup ".. fBackup.." with fName ".. fName);
                                                                                        fBNum = fNum;
                                                                                        fNum = lttcnt;
                                                                                        fBagNum = bagID;
                                                                                        fSlotNum = slot;
                                                                                        fBackup = fName;
                                                                                        fName = itemnumber;
                                                                                        fIcon = cntitem;
                                                                                elseif ( (lttcnt > fBNum)  and (lttcnt < fNum)) then
                                                                                        --GiveMeHealth_Print("2Replacing fBNum ".. fBNum.." with lttcnt ".. lttcnt);
                                                                                        --GiveMeHealth_Print("2Replacing fBackup ".. fBackup.." with itemnumber ".. itemnumber);
                                                                                        fBNum = lttcnt;
                                                                                        fBackup = itemnumber;
										end
									end
									tHCnt =  tHCnt + icnt;
								end
							end
						end	
						
					end			
					
				end
				
			end
		end
		
	end
	
	GMH_PotionCnt[macroName] = tHCnt;
		
	if ( dontuse == true ) then
		if ( fNum > 0 ) then
			return fName, fIcon;
		end 
		return fName, nil;
		
	elseif ( fNum > 0 ) then
		
		--UseContainerItem(fBagNum,fSlotNum);
		if (macroName == GMH_MACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_MACRONAME] == nil or GMH_LastBackup[GMH_MACRONAME] ==nil) or (GMH_LastItem[GMH_MACRONAME] ~= fName or GMH_LastBackup[GMH_MACRONAME] ~= fBackup) then
				--GiveMeHealth_Print("Preping "..fName);
				EditMacro(GMH_MACRONAME,GMH_MACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";[mod:ctrl] "..ALCH.."\n/gmh update=health\n/use [combat, nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";\n/cast [mod:ctrl] "..ALCH.." ",true);
				GMH_LastItem[GMH_MACRONAME] = fName;
				GMH_LastBackup[GMH_MACRONAME] = fBackup;
			end
		elseif (macroName == GMH_MANAMACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_MANAMACRONAME] == nil or GMH_LastBackup[GMH_MANAMACRONAME] == nil) or (GMH_LastItem[GMH_MANAMACRONAME] ~= fName or GMH_LastBackup[GMH_MANAMACRONAME] ~= fBackup) then
				--GiveMeHealth_Print("Preping "..fName);
				EditMacro(GMH_MANAMACRONAME,GMH_MANAMACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";[mod:ctrl] "..ALCH.."\n/gmh update=mana\n/use [combat, nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";/cast [mod:ctrl] "..ALCH.." ",true);
				GMH_LastItem[GMH_MANAMACRONAME] = fName;
				GMH_LastBackup[GMH_MANAMACRONAME] = fBackup;
			end
		end 
		
		return fName, fIcon;
	else
		if (macroName == GMH_MACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Health Potions");
			EditMacro(GMH_MACRONAME,GMH_MACRONAME,7,"/gmh update=health\n/cast [mod:ctrl] "..ALCH.." ",0);
			GMH_LastItem[GMH_MACRONAME] = nil;
			GMH_LastBackup[GMH_MACRONAME] = nil;
		elseif (macroName == GMH_MANAMACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Mana Potions");
			EditMacro(GMH_MANAMACRONAME,GMH_MANAMACRONAME,331,"/gmh update=mana\n/cast [mod:ctrl] "..ALCH.." ",0);
			GMH_LastItem[GMH_MANAMACRONAME] = nil;
			GMH_LastBackup[GMH_MANAMACRONAME] = nil;
		end 
		
		return fName, nil;
	end
		
end

function GMB_Go(macroName)
        local fNum = 0;
        local fName = "";
        local fBNum = 0;
        local fBackup = "";
        local exact = "no";
        local SECexact = "no";
        local TERexact = "no";
        local primary = "no";
        local secondary = "no";
        local tertiary = "no";
        
        if (macroName == GMH_BUFFMACRONAME) then
                fName = "No Buff Food";
                TempArray = GMH_Buff;
        end
        
        for bagID = 0, 4, 1 do
                local cnt = GetContainerNumSlots(bagID);
                if (cnt > 0) then
                        for slot = 1, cnt, 1 do
                                local link = GetContainerItemLink(bagID, slot);
                                local itemNumber = GiveMeHealth_NameFromLink(link);
                                if (itemNumber) then
                                        --GiveMeHealth_Print(itemNumber);
                                        for index = 1, table.getn(TempArray), 1 do
                                                if (TempArray[index][1] == itemNumber) then
                                                        --GiveMeHealth_Print(itemNumber);
                                                        if (TempArray[index][2] <= UnitLevel("player")) then
                                                                --GiveMeHealth_Print("Can use "..link);
                                                                --GiveMeHealth_Print("How does it rank?");
                                                                if (((TempArray[index][3] == PRIMARYbuff) and (TempArray[index][4] == SECONDARYbuff)) or ((TempArray[index][3] == SECONDARYbuff) and (TempArray[index][4] == PRIMARYbuff))) then
                                                                        --GiveMeHealth_Print("Found EXACT "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if ((index > fNum) or (exact == "no")) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                exact = "yes";
                                                                        elseif (((index > fBNum) and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                
                                                                elseif (((TempArray[index][3] == PRIMARYbuff) and (TempArray[index][4] == TERTIARYbuff)) or ((TempArray[index][3] == TERTIARYbuff) and (TempArray[index][4] == PRIMARYbuff))) then
                                                                        
                                                                        --GiveMeHealth_Print("Found SECONDARY EXACT "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if (((exact == "no") and (index > fNum)) or ((exact == "no") and (SECexact == "no"))) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                SECexact = "yes";
                                                                        elseif (((exact == "no") and (index > fBNum)  and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                
                                                                elseif (((TempArray[index][3] == SECONDARYbuff) and (TempArray[index][4] == TERTIARYbuff)) or ((TempArray[index][3] == TERTIARYbuff) and (TempArray[index][4] == SECONDARYbuff))) then
                                                                        
                                                                        --GiveMeHealth_Print("Found TERTIARY EXACT "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if (((exact == "no") and (SECexact == "no") and (index > fNum)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no"))) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                TERexact = "yes";
                                                                        elseif (((exact == "no") and (SECexact == "no") and (index > fBNum) and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                
                                                                elseif (((TempArray[index][3] == PRIMARYbuff) or (TempArray[index][4] == PRIMARYbuff))) then
                                                                        --GiveMeHealth_Print("Primary buff CHECK");
                                                                        --GiveMeHealth_Print(exact);
                                                                        --GiveMeHealth_Print(SECexact);
                                                                        --GiveMeHealth_Print(TERexact);
                                                                        --GiveMeHealth_Print(primary);
                                                                        
                                                                        --GiveMeHealth_Print("Found PRIMARY "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > fNum)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no"))) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                primary = "yes";
                                                                        elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (index > fBNum) and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                
                                                                elseif (((TempArray[index][3] == SECONDARYbuff) or (TempArray[index][4] == SECONDARYbuff))) then
                                                                        
                                                                        --GiveMeHealth_Print("Found SECONDARY "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > fNum)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no"))) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                secondary = "yes";
                                                                        elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (index > fBNum) and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                
                                                                
                                                                elseif (((TempArray[index][3] == TERTIARYbuff) or (TempArray[index][4] == TERTIARYbuff))) then
                                                                        
                                                                        --GiveMeHealth_Print("Found TERTIARY "..link);
                                                                        --GiveMeHealth_Print("index is "..index.."|fNum is "..fNum);
                                                                        
                                                                        if (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > fNum)) or ((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (tertiary == "no"))) then
                                                                                --GiveMeHealth_Print("Replacing fName: "..fName.." with link: "..itemNumber);
                                                                                fBNum = fNum;
                                                                                fNum = index;
                                                                                --GiveMeHealth_Print("Replacing fBackup: "..fBackup.." with fName: "..fName);
                                                                                fBackup = fName;
                                                                                fName = itemNumber;
                                                                                tertiary = "yes";
                                                                        elseif (((exact == "no") and (SECexact == "no") and (TERexact == "no") and (primary == "no") and (secondary == "no") and (index > fBNum) and (index < fNum)) or (fBackup == "No Buff Food")) then
                                                                                if (index ~= fNum) then
                                                                                        --GiveMeHealth_Print("Not as good, but replacing fBackup: "..fBackup.." with link: "..itemNumber);
                                                                                        fBNum = index;
                                                                                        fBackup = itemNumber;
                                                                                end
                                                                        end
                                                                end
                                                        end
                                                end
                                        end
                                end
                        end
                end
        end
 
        if (fNum > 0) then
		if (macroName == GMH_BUFFMACRONAME and notInCombat) then
			if (GMH_LastItem[GMH_BUFFMACRONAME] == nil or GMH_LastBackup[GMH_BUFFMACRONAME] == nil) or (GMH_LastItem[GMH_BUFFMACRONAME] ~= fName or GMH_LastBackup[GMH_BUFFMACRONAME] ~= fBackup) then
				--GiveMeHealth_Print("Buffing "..fName);
				EditMacro(GMH_BUFFMACRONAME,GMH_BUFFMACRONAME,1,"#showtooltip [nomod] item:"..fName..";[mod:alt] item:"..fName..";[mod:shift] item:"..fBackup..";[mod:ctrl] "..CAMPFIRE.."\n/gmh update=buff\n/use [button:1, nomod] item:"..fName..";[mod:shift] item:"..fBackup..";\n/cast [button:1, mod:ctrl] "..CAMPFIRE.." ",true);
				GMH_LastItem[GMH_BUFFMACRONAME] = fName;
				GMH_LastBackup[GMH_BUFFMACRONAME] = fBackup;
			end
		end 
                return fName;
        else
		if (macroName == GMH_BUFFMACRONAME and notInCombat) then
			--GiveMeHealth_Print("Out of Buffs");
			EditMacro(GMH_BUFFMACRONAME,GMH_BUFFMACRONAME,766,"/gmh update=buff\n/cast [mod:ctrl] "..CAMPFIRE.." ",0);
			GMH_LastItem[GMH_BUFFMACRONAME] = nil;
			GMH_LastBackup[GMH_BUFFMACRONAME] = nil;
                end
                return fName;
        end
end

function GiveMeHealth_NameFromLink(link)
	if( not link ) then
		return nil;
	end
	local _, _, itemnumber = strfind(link, "item:(%d+):")
	
	return itemnumber;
end
